/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import * as tslib_1 from "tslib";
import { MarkerSeries } from "./MarkerSeries";
import { Base, Type, runOn, Number_$type, enumGetBox, typeCast, Point_$type, fromEnum, markType } from "igniteui-react-core/ES5/type";
import { PolarAxisInfoCache } from "./PolarAxisInfoCache";
import { SeriesRenderer$2 } from "./SeriesRenderer$2";
import { PolarFrame } from "./PolarFrame";
import { DependencyProperty } from "igniteui-react-core/ES5/DependencyProperty";
import { NumericAngleAxis } from "./NumericAngleAxis";
import { NumericRadiusAxis } from "./NumericRadiusAxis";
import { TrendLineType_$type } from "igniteui-react-core/ES5/TrendLineType";
import { Brush } from "igniteui-react-core/ES5/Brush";
import { PenLineCap_$type } from "igniteui-react-core/ES5/PenLineCap";
import { DoubleCollection } from "igniteui-react-core/ES5/DoubleCollection";
import { List$1 } from "igniteui-react-core/ES5/List$1";
import { SeriesPointOfInterest } from "./SeriesPointOfInterest";
import { ScalerParams } from "./ScalerParams";
import { Rect } from "igniteui-react-core/ES5/Rect";
import { Marker } from "./Marker";
import { MarkerSeriesView } from "./MarkerSeriesView";
import { PolarAxes } from "./PolarAxes";
import { IFastItemsSource_$type } from "igniteui-react-core/ES5/IFastItemsSource";
import { SeriesRenderingArguments } from "./SeriesRenderingArguments";
import { AxisRange } from "./AxisRange";
import { HashPool$2 } from "igniteui-react-core/ES5/HashPool$2";
import { Clipper } from "igniteui-react-core/ES5/Clipper";
import { Dictionary$2 } from "igniteui-react-core/ES5/Dictionary$2";
import { OwnedPoint } from "./OwnedPoint";
import { PolarTrendLineManager } from "./PolarTrendLineManager";
import { TrendResolutionParams } from "./TrendResolutionParams";
import { PropertyMetadata } from "igniteui-react-core/ES5/PropertyMetadata";
import { isNaN_, isInfinity } from "igniteui-react-core/ES5/number";
import { NumericMarkerManager } from "./NumericMarkerManager";
import { GeometryGroup } from "igniteui-react-core/ES5/GeometryGroup";
import { stringIsNullOrEmpty } from "igniteui-react-core/ES5/string";
var PolarBase = /** @class */ (function (_super) {
    tslib_1.__extends(PolarBase, _super);
    function PolarBase() {
        var _this = _super.call(this) || this;
        _this.mz = null;
        _this.ms = null;
        _this.mx = null;
        _this.op = null;
        _this.oo = null;
        _this.m5 = null;
        _this.m7 = null;
        _this.m8 = null;
        _this.m2 = new PolarFrame();
        _this.m4 = new PolarFrame();
        _this.m1 = new PolarFrame();
        _this.mw = null;
        _this.m3 = null;
        _this.m0 = null;
        _this.m3 = new PolarFrame();
        _this.m4.x = runOn(_this, _this.on);
        _this.m2.x = runOn(_this, _this.on);
        _this.m1.x = runOn(_this, _this.on);
        _this.m5 = new SeriesRenderer$2(PolarFrame.$, PolarBaseView.$, 0, runOn(_this, _this.n0), runOn(_this, _this.n2), runOn(_this, _this.ca), runOn(_this, _this.jc), runOn(_this, _this.ny));
        return _this;
    }
    PolarBase.prototype.bf = function () {
        return new PolarBaseView(this);
    };
    PolarBase.prototype.il = function (a) {
        _super.prototype.il.call(this, a);
        this.my = a;
    };
    PolarBase.prototype.hm = function () {
        _super.prototype.hm.call(this);
        this.mu = null;
        this.mv = null;
    };
    PolarBase.prototype.get_c0 = function () {
        return true;
    };
    PolarBase.prototype.ne = function (a) {
        var _this = this;
        if (!this.hasMarkers) {
            return false;
        }
        var b = this.mu;
        var c = new ScalerParams(1, this.bs.mn, this.lp, b.b8);
        c.c = this.getEffectiveViewport1(this.bi);
        var d = this.mv;
        var e = new ScalerParams(1, this.bs.mn, this.lp, d.b8);
        e.c = this.getEffectiveViewport1(this.bi);
        a.clear();
        this.lr.cc(function (f) {
            if (f._visibility == 0) {
                var g = new SeriesPointOfInterest();
                var h = f.n;
                var i = f.o;
                if (h < _this.lp.left || h > _this.lp.right || i < _this.lp.top || i > _this.lp.bottom) {
                    return;
                }
                g.b = b.dw(h, c);
                g.c = d.dw(i, e);
                g.a = f.content;
                a.add(g);
            }
        });
        return true;
    };
    PolarBase.prototype.ny = function () {
        if (this.bt.g) {
            this.bt.t();
        }
    };
    PolarBase.prototype.nz = function () {
        this.mw.e(this.mz.w, this.m9, this.na, this.op, this.oo, function (a, b) { return Math.cos(b); }, function (a, b) { return Math.sin(b); }, true);
    };
    Object.defineProperty(PolarBase.prototype, "m9", {
        get: function () {
            return this.m7;
        },
        set: function (a) {
            if (this.m7 != a) {
                var b = this.m9;
                this.m7 = a;
                this.raisePropertyChanged("AngleColumn", b, this.m9);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(PolarBase.prototype, "na", {
        get: function () {
            return this.m8;
        },
        set: function (a) {
            if (this.m8 != a) {
                var b = this.na;
                this.m8 = a;
                this.raisePropertyChanged("RadiusColumn", b, this.na);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(PolarBase.prototype, "oi", {
        get: function () {
            return this.c(PolarBase.n3);
        },
        set: function (a) {
            this.h(PolarBase.n3, a);
        },
        enumerable: true,
        configurable: true
    });
    PolarBase.prototype.h3 = function () {
        _super.prototype.h3.call(this);
        if (this.mv != null) {
            this.mv.g0(false);
        }
        if (this.mu != null) {
            this.mu.g0(false);
        }
    };
    PolarBase.prototype.hr = function (a, b, c, d) {
        var e = false;
        this.my.cr.g$e(a, b, c, d);
        if (this.mu != null && !this.mu.ck()) {
            e = true;
        }
        if (this.mv != null && !this.mv.ck()) {
            e = true;
        }
        if (e) {
            this.i4(true);
        }
    };
    PolarBase.prototype.jj = function (a, b) {
        this.i4(false);
    };
    PolarBase.prototype.jk = function (a, b) {
        this.i4(false);
    };
    PolarBase.prototype.du = function (a, b, c) {
        var d = true;
        if (!_super.prototype.du.call(this, a, b, c) || !c.l() || b.isEmpty || a.isEmpty || this.mu == null || this.mv == null || this.m9 == null || this.na == null || this.m9.count == 0 || this.na.count == 0 || this.bz == null || this.bz.count != this.m9.count || this.bz.count != this.na.count || this.mw == null || this.mu.bf == null || this.mv.bf == null || this.mu.jx == this.mu.jw || this.mv.jx == this.mv.jw) {
            d = false;
        }
        return d;
    };
    PolarBase.prototype.i5 = function (a) {
        var b;
        var c;
        var d = this.getViewInfo(c, b);
        c = d.p0;
        b = d.p1;
        if (!this.du(c, b, this.bi)) {
            this.ho(true, this.bi);
            return;
        }
        this.op = b;
        this.oo = c;
        this.mx = new PolarAxisInfoCache(this.mu, this.mv, this.bz);
        var e = new SeriesRenderingArguments(this, c, b, a, this.dc);
        var f = this.m5.g(e, this.m2, this.m1, this.m4, this.my);
        this.m2 = f.p1;
        this.m1 = f.p2;
        this.m4 = f.p3;
    };
    PolarBase.prototype.on = function (a) {
        var b = this.mw.h(a.x, a.y, this.op, this.oo, this.mx.e, this.mx.d, this.mx.g, this.mx.f, this.mx.i, this.mx.h);
        return b;
    };
    PolarBase.prototype.an = function (a) {
        if (a != null && a == this.mu && this.m9 != null) {
            return new AxisRange(this.m9.minimum, this.m9.maximum);
        }
        if (a != null && a == this.mv && this.na != null) {
            return new AxisRange(this.na.minimum, this.na.maximum);
        }
        return null;
    };
    PolarBase.prototype.c7 = function (a) {
        var b = this.bi.bs;
        b = b.copy();
        var c = this.bi.br;
        var d = !b.isEmpty && !c.isEmpty && this.bz != null ? this.bz.indexOf(a) : -1;
        if (this.mu == null || this.m9 == null || this.mv == null || this.na == null) {
            return false;
        }
        if (d < 0 || d > this.m9.count - 1 || d > this.na.count - 1) {
            return false;
        }
        var e = this.mu.getScaledAngle(this.m9.item(d));
        var f = this.mv.li(this.na.item(d));
        var g = 0.5 + (Math.cos(e) * f);
        var h = 0.5 + (Math.sin(e) * f);
        if (!isNaN_(g)) {
            if (g < b.left + 0.1 * b.width) {
                g = g + 0.4 * b.width;
                b.x = g - 0.5 * b.width;
            }
            if (g > b.right - 0.1 * b.width) {
                g = g - 0.4 * b.width;
                b.x = g - 0.5 * b.width;
            }
        }
        if (!isNaN_(h)) {
            if (h < b.top + 0.1 * b.height) {
                h = h + 0.4 * b.height;
                b.y = h - 0.5 * b.height;
            }
            if (h > b.bottom - 0.1 * b.height) {
                h = h - 0.4 * b.height;
                b.y = h - 0.5 * b.height;
            }
        }
        if (this.bn != null) {
            this.bn.ap(this.bs, b, true);
        }
        return d >= 0;
    };
    PolarBase.prototype.fl = function (a) {
        return null;
    };
    PolarBase.prototype.e4 = function (a) {
        return -1;
    };
    PolarBase.prototype.ag = function () {
        return [this.mu, this.mv];
    };
    PolarBase.prototype.ir = function (a, b, c, d) {
        _super.prototype.ir.call(this, a, b, c, d);
        if (this.my.cr.g$b(a, b, c, d)) {
            this.i4(false);
            this.ib();
        }
        switch (b) {
            case "FastItemsSource":
                if (typeCast(IFastItemsSource_$type, c) != null) {
                    c.deregisterColumn(this.m9);
                    c.deregisterColumn(this.na);
                    this.m9 = null;
                    this.na = null;
                }
                if (typeCast(IFastItemsSource_$type, d) != null) {
                    this.m9 = this.bw(this.nn);
                    this.na = this.bw(this.nt);
                }
                if ((this.mv != null && !this.mv.ck()) || (this.mu != null && !this.mu.ck())) {
                    this.i4(false);
                }
                break;
            case PolarBase.$$p[0]:
                if (this.mu != null && this.mv != null) {
                    this.mw = new PolarAxes(this.mv, this.mu);
                }
                if (c != null) {
                    c.bv(this);
                }
                if (d != null) {
                    d.ch(this);
                }
                if (this.mu != null && !this.mu.ck()) {
                    this.i4(false);
                }
                else if (c != null && d == null) {
                    this.ho(true, this.bi);
                }
                break;
            case PolarBase.$$p[4]:
                if (this.mu != null && this.mv != null) {
                    this.mw = new PolarAxes(this.mv, this.mu);
                }
                if (c != null) {
                    c.bv(this);
                }
                if (d != null) {
                    d.ch(this);
                }
                if (this.mv != null && !this.mv.ck()) {
                    this.i4(false);
                }
                else if (c != null && d == null) {
                    this.ho(true, this.bi);
                }
                if (this.mu != null && !this.mu.ck()) {
                    this.mu.gw();
                }
                break;
            case PolarBase.$$p[1]:
                if (this.bz != null) {
                    this.bz.deregisterColumn(this.m9);
                    this.m9 = this.bw(this.nn);
                }
                break;
            case "AngleColumn":
                this.my.cr.g$i();
                if (this.mu != null && !this.mu.ck()) {
                    this.i4(false);
                }
                break;
            case PolarBase.$$p[5]:
                if (this.bz != null) {
                    this.bz.deregisterColumn(this.na);
                    this.na = this.bw(this.nt);
                }
                break;
            case "RadiusColumn":
                this.my.cr.g$i();
                if (this.mv != null && !this.mv.ck()) {
                    this.i4(false);
                }
                break;
            case PolarBase.$$p[6]:
                this.i4(false);
                this.ib();
                break;
            case PolarBase.$$p[3]:
                this.i4(false);
                this.ib();
                break;
            case "TransitionProgress":
                this.mx = new PolarAxisInfoCache(this.mu, this.mv, this.bz);
                this.op = this.bi.bs;
                this.oo = this.bi.br;
                this.m4.v = this.nf;
                this.m4.c(this.ev, this.m2, this.m1);
                if (this.cc(this.bi)) {
                    return;
                }
                if (this.ev == 1) {
                    this.n2(this.m1, this.my);
                }
                else {
                    this.n2(this.m4, this.my);
                }
                if (this.bs != null) {
                    this.bs.jh(this);
                }
                break;
            case "TrendLineBrush":
                this.jf();
                break;
            case PolarBase.$$p[2]:
                this.i4(false);
                this.ib();
                break;
            case "TrendLineType":
                this.ib();
                break;
        }
    };
    PolarBase.prototype.nc = function (a) {
        if (typeCast(NumericRadiusAxis.$, a) !== null) {
            return true;
        }
        return false;
    };
    PolarBase.prototype.nb = function (a) {
        if (typeCast(NumericAngleAxis.$, a) !== null) {
            return true;
        }
        return false;
    };
    PolarBase.prototype.ho = function (a, b) {
        _super.prototype.ho.call(this, a, b);
        var c = b;
        if (a) {
            c.cs.clear();
        }
        c.cr.g$d();
    };
    PolarBase.prototype.mt = function (a, b) {
        var c = a.top - 10;
        var d = a.bottom + 10;
        var e = a.left - 10;
        var f = a.right + 10;
        var g = ((function () {
            var $ret = new Clipper(1, e, d, f, c, false);
            $ret.i = b;
            return $ret;
        })());
        return g;
    };
    PolarBase.prototype.nx = function (a, b, c, d) {
        a.g = new Dictionary$2(Base.$, OwnedPoint.$, 1, b);
        var e = this.bz;
        var _loop_1 = function (f) {
            var g = a.w._inner[f];
            if (!isInfinity(g.x) && !isInfinity(g.y)) {
                var h_1 = { $type: Point_$type, x: this_1.m9.item(f), y: this_1.na.item(f) };
                var i_1 = { $type: Point_$type, x: g.x, y: g.y };
                a.g.addItem(e.item(f), ((function () {
                    var $ret = new OwnedPoint();
                    $ret.a = e.item(f);
                    $ret.b = h_1;
                    $ret.c = i_1;
                    return $ret;
                })()));
            }
        };
        var this_1 = this;
        for (var f = 0; f < b; f++) {
            _loop_1(f);
        }
    };
    PolarBase.prototype.n0 = function (a, b) {
        var _this = this;
        var c = b.bs;
        var d = b.br;
        a.j.clear();
        a.n.clear();
        var e = Math.min(this.m9 != null ? this.m9.count : 0, this.na != null ? this.na.count : 0);
        if (e < 1) {
            return;
        }
        this.mx = new PolarAxisInfoCache(this.mu, this.mv, this.bz);
        this.mz = a;
        this.oo = d;
        this.op = c;
        b.cp.l(a.j, this.ni, c, d, this.eq);
        if (e <= this.ni) {
            this.nx(a, e, c, d);
        }
        var f = this.mt(d, a.n);
        var g = Math.min(this.mu.jx, this.mu.jw);
        var h = Math.max(this.mu.jw, this.mu.jx);
        b.cr.q = this.nf;
        b.cr.p = 0;
        b.cr.s = this.mv.lc;
        b.cr.r = this.mv.lb;
        b.cr.t = function (i, j) { return _this.mw.c(i, j, c, d, Math.cos); };
        b.cr.u = function (i, j) { return _this.mw.d(i, j, c, d, Math.sin); };
        var i = new List$1(Number_$type, 0);
        for (var j = 0; j < this.m9.count; j++) {
            if (this.m9.item(j) >= g && this.m9.item(j) <= h) {
                i.add(this.m9.item(j));
            }
        }
        var k = this.na;
        if (i.count != this.m9.count) {
            k = new List$1(Number_$type, 0);
            for (var l = 0; l < this.m9.count; l++) {
                if (this.m9.item(l) >= g && this.m9.item(l) <= h) {
                    k.add(this.na.item(l));
                }
            }
        }
        b.cr.v(a.n, this.m6, i, k, this.nj, runOn(this.mu, this.mu.getScaledAngle), runOn(this.mv, this.mv.li), ((function () {
            var $ret = new TrendResolutionParams();
            $ret.b = _this.eq;
            $ret.f = d;
            $ret.g = c;
            return $ret;
        })()), f, g, h);
    };
    PolarBase.prototype.n2 = function (a, b) {
        var c = b.bs;
        var d = b.br;
        var e = this.getEffectiveViewport1(b);
        var f = this.lh(b);
        this.mx = new PolarAxisInfoCache(this.mu, this.mv, this.bz);
        b.cp.j(a.j, this.lw);
        b.cj();
        var g = this.mt(d, b.cr.g$j.aj);
        b.cr.g$h(a.n, g);
        this.nw(d, c, e, f, b);
    };
    PolarBase.prototype.nw = function (a, b, c, d, e) {
        e.cu(a, b, c, d);
    };
    PolarBase.prototype.jf = function () {
        _super.prototype.jf.call(this);
        if (this.fd < 0) {
            return;
        }
        this.my.cw();
    };
    PolarBase.prototype.i6 = function (a, b) {
        _super.prototype.i6.call(this, a, b);
        if (!this.dj) {
            this.bi.az(b);
            return;
        }
        this.bi.az(b);
        if (this.cc(this.bh)) {
            return;
        }
        var c = this.bh;
        if (!this.dd) {
            this.m3 = new PolarFrame();
            this.n0(this.m3, c);
        }
        this.dd = false;
        this.n2(this.m3, c);
        this.dj = false;
    };
    PolarBase.prototype.i3 = function (a, b, c, d, e) {
        _super.prototype.i3.call(this, a, b, c, d, e);
        var f = this.a0.a$h.item(d);
        var g = f;
        f.ay(c);
        if (this.cc(g)) {
            return;
        }
        if (this.m0 == null) {
            this.m0 = new PolarFrame();
        }
        this.n0(this.m0, g);
        this.n2(this.m0, g);
    };
    PolarBase.prototype.n1 = function (a, b) {
        var e_1, _a, e_2, _b;
        var c = new List$1(Base.$, 0);
        try {
            for (var _c = tslib_1.__values(fromEnum(b.c)), _d = _c.next(); !_d.done; _d = _c.next()) {
                var d = _d.value;
                if (!a.containsKey(d)) {
                    c.add1(d);
                }
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (_d && !_d.done && (_a = _c.return)) _a.call(_c);
            }
            finally { if (e_1) throw e_1.error; }
        }
        try {
            for (var _e = tslib_1.__values(fromEnum(c)), _f = _e.next(); !_f.done; _f = _e.next()) {
                var e = _f.value;
                b.g(e);
            }
        }
        catch (e_2_1) { e_2 = { error: e_2_1 }; }
        finally {
            try {
                if (_f && !_f.done && (_b = _e.return)) _b.call(_e);
            }
            finally { if (e_2) throw e_2.error; }
        }
    };
    PolarBase.prototype.mr = function (a, b, c) {
        this.nz();
        return this.mz.w.toArray();
    };
    PolarBase.prototype.ng = function (a) {
        var e_3, _a;
        var b = new List$1(Number_$type, 0);
        var c = this.bz;
        try {
            for (var _b = tslib_1.__values(fromEnum(this.my.cs.c)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var d = _c.value;
                b.add(c.indexOf(d));
            }
        }
        catch (e_3_1) { e_3 = { error: e_3_1 }; }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
            }
            finally { if (e_3) throw e_3.error; }
        }
        return b;
    };
    PolarBase.prototype.om = function (a) {
        return { $type: Point_$type, x: this.m9.item(a), y: this.na.item(a) };
    };
    PolarBase.prototype.hx = function (a) {
        _super.prototype.hx.call(this, a);
        this.a2.exportTrendlineData(this, a, this.my.cr.g$j);
    };
    PolarBase.$t = markType(PolarBase, 'PolarBase', MarkerSeries.$);
    PolarBase.n3 = DependencyProperty.i("ActualTrendLineBrush", Brush.$, PolarBase.$, new PropertyMetadata(2, null, function (a, b) { return a.raisePropertyChanged("ActualTrendLineBrush", b.oldValue, b.newValue); }));
    return PolarBase;
}(MarkerSeries));
export { PolarBase };
Type.dep(DependencyProperty, PropertyMetadata, PolarBase, 'raisePropertyChanged', ['AngleAxis:mu:n4', [NumericAngleAxis.$, null], 'AngleMemberPath:nn:n5', [2], 'ClipSeriesToBounds:nd:n6', [0, false], 'MaximumMarkers:ni:n7', [1, 400], 'RadiusAxis:mv:n8', [NumericRadiusAxis.$, null], 'RadiusMemberPath:nt:n9', [2], 'UseCartesianInterpolation:nf:oh', [0, true], 'TrendLineType:m6:of', [TrendLineType_$type, enumGetBox(TrendLineType_$type, 0)], 'TrendLineThickness:nh:oe', [1, 1.5], 'TrendLinePeriod:nj:od', [1, 7], 'TrendLineZIndex:nk:og', [1, 1], 'TrendLineBrush:oj:oa', [Brush.$, null], 'TrendLineDashArray:ok:ob', [DoubleCollection.$], 'TrendLineDashCap:ol:oc', [PenLineCap_$type, enumGetBox(PenLineCap_$type, 0)]]);
var PolarBaseView = /** @class */ (function (_super) {
    tslib_1.__extends(PolarBaseView, _super);
    function PolarBaseView(a) {
        var _this = _super.call(this, a) || this;
        _this.cq = null;
        _this.cp = null;
        _this.cr = null;
        _this.cs = null;
        _this.cq = a;
        _this.cs = new HashPool$2(Base.$, Marker.$);
        _this.ce(_this.cs);
        _this.cr = new PolarTrendLineManager();
        return _this;
    }
    PolarBaseView.prototype.ap = function () {
        _super.prototype.ap.call(this);
        this.cp = this.co();
        if (!this.n) {
            this.cq.ni = 1000;
            this.by.ls = 2;
        }
    };
    PolarBaseView.prototype.co = function () {
        var _this = this;
        var a = new NumericMarkerManager(0, function (b) { return _this.cs.item(b); }, function (b) { return _this.cq.mx.c.item(b); }, runOn(this, this.cv), runOn(this, this.cn), runOn(this, this.ct));
        a.n = true;
        a.p = runOn(this.cq, this.cq.om);
        return a;
    };
    PolarBaseView.prototype.cv = function (a) {
        this.cq.n1(a, this.cs);
    };
    PolarBaseView.prototype.cn = function () {
        return this.cq.mr(this.cs, this.bs, this.br);
    };
    PolarBaseView.prototype.ct = function () {
        return this.cq.ng(this.cs);
    };
    PolarBaseView.prototype.cu = function (a, b, c, d) {
        if (this.cq.nd) {
            var e = new GeometryGroup();
            this.cq.mv.lq(e, a, b, c, d);
        }
        else {
        }
    };
    PolarBaseView.prototype.cw = function () {
        if (this.cq.oj != null) {
            this.cq.oi = this.cq.oj;
        }
        else {
            this.cq.oi = this.cq.ku;
        }
    };
    PolarBaseView.prototype.cc = function (a) {
        this.cs.f(a);
    };
    PolarBaseView.prototype.a2 = function (a, b) {
        if (a.d) {
            if (this.cq.m6 != 0 && !b) {
                var c = this.cr.g$j;
                c.ac = this.cq.nh;
                c._stroke = this.cq.oi;
                c.ad = this.cq.ol;
                c.ai = this.cq.ok;
                a.u(c);
            }
        }
        _super.prototype.a2.call(this, a, b);
    };
    PolarBaseView.prototype.cx = function () {
        return Rect.empty;
    };
    PolarBaseView.prototype.getDefaultTooltipTemplate = function () {
        var a = "<div class='ui-chart-default-tooltip-content'><span>" + "${item." + this.cq.nn + "}" + "</span><br/><span";
        var b = this.e.a0.a$q(this.e);
        if (!stringIsNullOrEmpty(b)) {
            a += " style='color:" + b + "'";
        }
        a += ">" + this.cq.fr + ": </span><span class='ui-priority-primary'>" + "${item." + this.cq.nt + "}</span></div>";
        return a;
    };
    PolarBaseView.$t = markType(PolarBaseView, 'PolarBaseView', MarkerSeriesView.$);
    return PolarBaseView;
}(MarkerSeriesView));
export { PolarBaseView };
